import type {Server} from 'socket.io';
import type {Socket} from 'socket.io-client';
import type {IBaseWorld} from './world.js';
import {Clock} from 'three';
import type {IPhysicsObject} from './physics';

export type TrooniaState = {
  objects: {[id: string]: IPhysicsObject};
}

export abstract class BaseTroonia {
  clock: Clock = new Clock();
}

export interface IBaseTroonia extends BaseTroonia {
  socket: Socket|Server;
  world: IBaseWorld;
  update(): void;
  onConnect(socket?: any): void;
  onDisconnect(message: any, socket?: any): void;
}
